# Host:
# Database: test
# Table: 'catalog'
#
CREATE TABLE `catalog` (
  `uid` BIGINT UNSIGNED NOT NULL,
  `security_uid` INT UNSIGNED,
  `path` varchar(255) NOT NULL default '',
  `owner` varchar(32) NOT NULL default '',
  `relative_url` varchar(255) NOT NULL default '',
  `parent_uid` BIGINT UNSIGNED default '0',
  `id` varchar(255) default '',
  `description` text,
  `title` varchar(255) default '',
  `portal_type` varchar(255) default '',
  `validation_state` varchar(255) default '',
  `simulation_state` varchar(255) default '',
  `reference` varchar(255) default '',
  `source_reference` varchar(255) default '',
  `string_index` varchar(255),
  `int_index` INT,
  `has_cell_content` bool,
  `creation_date` datetime,
  `modification_date` datetime,
  `start_date` datetime,
  `stop_date` datetime,
  `indexation_date` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY  (`uid`),
  KEY `owner` (`owner`),
  KEY `Parent` (`parent_uid`, `security_uid`),
  KEY `parent_simulation_security` (`parent_uid`, `simulation_state`, `security_uid`),
  KEY `validation_state` (`validation_state`, `portal_type`, `security_uid`),
  KEY `simulation_state` (`simulation_state`, `portal_type`, `security_uid`),
  KEY `source_reference` (`parent_uid`, `source_reference`),
  KEY `type_source_reference` (`portal_type`, `source_reference`),
  KEY `start_date` (`parent_uid`, `start_date`),
  KEY `reference` (`portal_type`, `reference`),
  KEY `Path` (`path`),
  KEY `relative_url` (`relative_url`),
  KEY `indexation_date` (`indexation_date`)
) ENGINE=InnoDB;
