CREATE TABLE `delivery` (
  `uid` BIGINT UNSIGNED NOT NULL,
  `source_uid` BIGINT UNSIGNED default '0',
  `destination_uid` BIGINT UNSIGNED default '0',
  `source_section_uid` BIGINT UNSIGNED default '0',
  `destination_section_uid` BIGINT UNSIGNED default '0',
  `resource_uid` BIGINT UNSIGNED default '0',
  `recoup_date` datetime default NULL,
  `source_payment_reference` varchar(255) default '',
  `destination_payment_reference` varchar(255) default '',
  `source_payment_internal_bank_account_number` varchar(255) default '',
  `destination_payment_internal_bank_account_number` varchar(255) default '',
  `source_total_asset_price` real default '0',
  PRIMARY KEY (`uid`),
  KEY `source_uid` (`source_uid`),
  KEY `destination_uid` (`destination_uid`),
  KEY `source_section_uid` (`source_section_uid`),
  KEY `destination_section_uid` (`destination_section_uid`),
  KEY `resource_uid` (`resource_uid`),
  KEY `source_reference` (`source_payment_reference`),
  KEY `destination_payment_reference` (`destination_payment_reference`),
  KEY `recoup_date` (`recoup_date`),
  KEY `source_payment_internal_bank_account_number` (`source_payment_internal_bank_account_number`),
  KEY `destination_payment_internal_bank_account_number` (`destination_payment_internal_bank_account_number`),
  KEY `source_total_asset_price` (`source_total_asset_price`)
) ENGINE=InnoDB
